Index: kernel/arch/ppc32/include/boot/boot.h
===================================================================
--- kernel/arch/ppc32/include/boot/boot.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/boot/boot.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,7 +37,4 @@
 
 #define BOOT_OFFSET  0x8000
-
-/* Temporary stack size for boot process */
-#define TEMP_STACK_SIZE  0x1000
 
 #define TASKMAP_MAX_RECORDS        32
Index: kernel/arch/ppc32/include/context_offset.h
===================================================================
--- kernel/arch/ppc32/include/context_offset.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/context_offset.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -75,7 +75,16 @@
 
 #ifdef __ASM__
-# include <arch/asm/regname.h>
 
-# ctx: address of the structure with saved context
+#ifdef KERNEL
+
+#include <arch/asm/regname.h>
+
+#else /* KERNEL */
+
+#include <libarch/regname.h>
+
+#endif /* KERNEL */
+
+/* ctx: address of the structure with saved context */
 .macro CONTEXT_SAVE_ARCH_CORE ctx:req
 	stw sp, OFFSET_SP(\ctx)
@@ -102,5 +111,5 @@
 .endm
 
-# ctx: address of the structure with saved context
+/* ctx: address of the structure with saved context */
 .macro CONTEXT_RESTORE_ARCH_CORE ctx:req
 	lwz sp, OFFSET_SP(\ctx)
Index: kernel/arch/ppc32/include/cpu.h
===================================================================
--- kernel/arch/ppc32/include/cpu.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/cpu.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -36,19 +36,4 @@
 #define KERN_ppc32_CPU_H_
 
-/* MSR bits */
-#define MSR_DR  (1 << 4)
-#define MSR_IR  (1 << 5)
-#define MSR_PR  (1 << 14)
-#define MSR_EE  (1 << 15)
-
-/* HID0 bits */
-#define HID0_STEN  (1 << 24)
-#define HID0_ICE   (1 << 15)
-#define HID0_DCE   (1 << 14)
-#define HID0_ICFI  (1 << 11)
-#define HID0_DCI   (1 << 10)
-
-#ifndef __ASM__
-
 #include <typedefs.h>
 #include <trace.h>
@@ -67,6 +52,4 @@
 }
 
-#endif /* __ASM__ */
-
 #endif
 
Index: kernel/arch/ppc32/include/exception.h
===================================================================
--- kernel/arch/ppc32/include/exception.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/exception.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,5 +37,5 @@
 
 #include <typedefs.h>
-#include <arch/cpu.h>
+#include <arch/msr.h>
 #include <trace.h>
 
Index: kernel/arch/ppc32/include/interrupt.h
===================================================================
--- kernel/arch/ppc32/include/interrupt.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/interrupt.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -45,4 +45,7 @@
 #define VECTOR_EXTERNAL             4
 #define VECTOR_DECREMENTER          8
+#define VECTOR_ITLB_MISS            13
+#define VECTOR_DTLB_MISS_LOAD       14
+#define VECTOR_DTLB_MISS_STORE      15
 
 extern void start_decrementer(void);
Index: kernel/arch/ppc32/include/istate.h
===================================================================
--- kernel/arch/ppc32/include/istate.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/istate.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -36,7 +36,15 @@
 #define KERN_ppc32_EXCEPTION_H_
 
-#include <typedefs.h>
-#include <arch/cpu.h>
 #include <trace.h>
+
+#ifdef KERNEL
+
+#include <arch/msr.h>
+
+#else /* KERNEL */
+
+#include <libarch/msr.h>
+
+#endif /* KERNEL */
 
 typedef struct istate {
@@ -73,5 +81,5 @@
 	uint32_t cr;
 	uint32_t pc;
-	uint32_t srr1;
+	uint32_t msr;
 	uint32_t lr;
 	uint32_t ctr;
@@ -90,10 +98,8 @@
 /** Return true if exception happened while in userspace
  *
- * The contexts of MSR register was stored in SRR1.
- *
  */
 NO_TRACE static inline int istate_from_uspace(istate_t *istate)
 {
-	return (istate->srr1 & MSR_PR) != 0;
+	return (istate->msr & MSR_PR) != 0;
 }
 
Index: kernel/arch/ppc32/include/mm/as.h
===================================================================
--- kernel/arch/ppc32/include/mm/as.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/mm/as.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -36,12 +36,12 @@
 #define KERN_ppc32_AS_H_
 
+#include <arch/mm/pht.h>
+
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
 
-#define KERNEL_ADDRESS_SPACE_START_ARCH  ((unsigned long) 0x80000000)
-#define KERNEL_ADDRESS_SPACE_END_ARCH    ((unsigned long) 0xffffffff)
-#define USER_ADDRESS_SPACE_START_ARCH    ((unsigned long) 0x00000000)
-#define USER_ADDRESS_SPACE_END_ARCH      ((unsigned long) 0x7fffffff)
-
-#define USTACK_ADDRESS_ARCH  (0x7fffffff - (PAGE_SIZE - 1))
+#define KERNEL_ADDRESS_SPACE_START_ARCH  UINT32_C(0x80000000)
+#define KERNEL_ADDRESS_SPACE_END_ARCH    UINT32_C(0xffffffff)
+#define USER_ADDRESS_SPACE_START_ARCH    UINT32_C(0x00000000)
+#define USER_ADDRESS_SPACE_END_ARCH      UINT32_C(0x7fffffff)
 
 typedef struct {
@@ -54,5 +54,7 @@
 #define as_create_arch(as, flags)       (as != as)
 #define as_deinstall_arch(as)
-#define as_invalidate_translation_cache(as, page, cnt)
+
+#define as_invalidate_translation_cache(as, page, cnt) \
+	pht_invalidate((as), (page), (cnt))
 
 extern void as_arch_init(void);
Index: kernel/arch/ppc32/include/mm/frame.h
===================================================================
--- kernel/arch/ppc32/include/mm/frame.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/mm/frame.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -39,5 +39,4 @@
 #define FRAME_SIZE   (1 << FRAME_WIDTH)
 
-#ifdef KERNEL
 #ifndef __ASM__
 
@@ -63,5 +62,4 @@
 
 #endif /* __ASM__ */
-#endif /* KERNEL */
 
 #endif
Index: kernel/arch/ppc32/include/mm/page.h
===================================================================
--- kernel/arch/ppc32/include/mm/page.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/mm/page.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -41,6 +41,4 @@
 #define PAGE_WIDTH  FRAME_WIDTH
 #define PAGE_SIZE   FRAME_SIZE
-
-#ifdef KERNEL
 
 #ifndef __ASM__
@@ -181,6 +179,4 @@
 #endif /* __ASM__ */
 
-#endif /* KERNEL */
-
 #endif
 
Index: kernel/arch/ppc32/include/mm/pht.h
===================================================================
--- kernel/arch/ppc32/include/mm/pht.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
+++ kernel/arch/ppc32/include/mm/pht.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ppc32mm
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_ppc32_PHT_H_
+#define KERN_ppc32_PHT_H_
+
+#include <arch/interrupt.h>
+#include <typedefs.h>
+
+/* Forward declaration. */
+struct as;
+
+extern void pht_init(void);
+extern void pht_refill(unsigned int, istate_t *);
+extern void pht_invalidate(struct as *, uintptr_t, size_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/ppc32/include/mm/tlb.h
===================================================================
--- kernel/arch/ppc32/include/mm/tlb.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/mm/tlb.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,5 +37,4 @@
 
 #include <arch/interrupt.h>
-#include <typedefs.h>
 
 #define WIMG_GUARDED    0x01
@@ -75,11 +74,5 @@
 } ptelo_t;
 
-extern void pht_init(void);
-extern void pht_refill(unsigned int, istate_t *);
-
-extern bool pht_refill_real(unsigned int, istate_t *)
-    __attribute__ ((section("K_UNMAPPED_TEXT_START")));
-extern void tlb_refill_real(unsigned int, uint32_t, ptehi_t, ptelo_t,
-    istate_t *) __attribute__ ((section("K_UNMAPPED_TEXT_START")));
+extern void tlb_refill(unsigned int, istate_t *);
 
 #endif
Index: kernel/arch/ppc32/include/msr.h
===================================================================
--- kernel/arch/ppc32/include/msr.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
+++ kernel/arch/ppc32/include/msr.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2005 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ppc32
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_ppc32_MSR_H_
+#define KERN_ppc32_MSR_H_
+
+/* MSR bits */
+#define MSR_DR  (1 << 4)
+#define MSR_IR  (1 << 5)
+#define MSR_PR  (1 << 14)
+#define MSR_EE  (1 << 15)
+
+/* HID0 bits */
+#define HID0_STEN  (1 << 24)
+#define HID0_ICE   (1 << 15)
+#define HID0_DCE   (1 << 14)
+#define HID0_ICFI  (1 << 11)
+#define HID0_DCI   (1 << 10)
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/ppc32/include/types.h
===================================================================
--- kernel/arch/ppc32/include/types.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/include/types.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,4 +37,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 
 typedef uint32_t uintptr_t;
Index: kernel/arch/ppc32/src/asm.S
===================================================================
--- kernel/arch/ppc32/src/asm.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/src/asm.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -28,5 +28,5 @@
 
 #include <arch/asm/regname.h>
-#include <arch/cpu.h>
+#include <arch/msr.h>
 
 .text
@@ -35,7 +35,4 @@
 .global iret
 .global iret_syscall
-.global memsetb
-.global memsetw
-.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
@@ -208,11 +205,4 @@
 	rfi
 
-memsetb:
-	b _memsetb
-
-memsetw:
-	b _memsetw
-
-memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
Index: kernel/arch/ppc32/src/boot/boot.S
===================================================================
--- kernel/arch/ppc32/src/boot/boot.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/src/boot/boot.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -28,5 +28,5 @@
 
 #include <arch/asm/regname.h>
-#include <arch/boot/boot.h>
+#include <config.h>
 
 .section K_TEXT_START, "ax"
@@ -56,4 +56,4 @@
 .align 12
 kernel_stack_bottom:
-	.space TEMP_STACK_SIZE
+	.space STACK_SIZE
 kernel_stack:
Index: kernel/arch/ppc32/src/exception.S
===================================================================
--- kernel/arch/ppc32/src/exception.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/src/exception.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -28,5 +28,5 @@
 
 #include <arch/asm/regname.h>
-#include <arch/cpu.h>
+#include <arch/msr.h>
 #include <arch/mm/page.h>
 
@@ -142,5 +142,6 @@
 	CONTEXT_STORE
 	
-	b data_storage
+	li r3, 2
+	b jump_to_kernel
 
 .org 0x400
@@ -149,5 +150,6 @@
 	CONTEXT_STORE
 	
-	b instruction_storage
+	li r3, 3
+	b jump_to_kernel
 
 .org 0x500
@@ -227,5 +229,6 @@
 	CONTEXT_STORE
 	
-	b tlb_miss
+	li r3, 13
+	b jump_to_kernel
 
 .org 0x1100
@@ -234,5 +237,6 @@
 	CONTEXT_STORE
 	
-	b tlb_miss
+	li r3, 14
+	b jump_to_kernel
 
 .org 0x1200
@@ -241,42 +245,8 @@
 	CONTEXT_STORE
 	
-	b tlb_miss
+	li r3, 15
+	b jump_to_kernel
 
 .org 0x4000
-data_storage:
-	li r3, 2
-	mr r4, sp
-	addi r4, r4, 8
-	bl pht_refill_real
-	
-	cmpwi r3, 0
-	bne iret_real
-	
-	li r3, 2
-	b jump_to_kernel
-
-instruction_storage:
-	li r3, 3
-	mr r4, sp
-	addi r4, r4, 8
-	bl pht_refill_real
-	
-	cmpwi r3, 0
-	bne iret_real
-	
-	li r3, 3
-	b jump_to_kernel
-
-tlb_miss:
-	li r3, 16
-	mfspr r4, tlbmiss
-	mfspr r5, ptehi
-	mfspr r6, ptelo
-	mr r7, sp
-	addi r7, r7, 20
-	
-	bl tlb_refill_real
-	b iret_real
-
 jump_to_kernel:
 	lis r12, iret@ha
@@ -313,57 +283,2 @@
 	addis sp, sp, 0x8000
 	rfi
-
-iret_real:
-	lwz r0, 8(sp)
-	lwz r2, 12(sp)
-	lwz r3, 16(sp)
-	lwz r4, 20(sp)
-	lwz r5, 24(sp)
-	lwz r6, 28(sp)
-	lwz r7, 32(sp)
-	lwz r8, 36(sp)
-	lwz r9, 40(sp)
-	lwz r10, 44(sp)
-	lwz r11, 48(sp)
-	lwz r13, 52(sp)
-	lwz r14, 56(sp)
-	lwz r15, 60(sp)
-	lwz r16, 64(sp)
-	lwz r17, 68(sp)
-	lwz r18, 72(sp)
-	lwz r19, 76(sp)
-	lwz r20, 80(sp)
-	lwz r21, 84(sp)
-	lwz r22, 88(sp)
-	lwz r23, 92(sp)
-	lwz r24, 96(sp)
-	lwz r25, 100(sp)
-	lwz r26, 104(sp)
-	lwz r27, 108(sp)
-	lwz r28, 112(sp)
-	lwz r29, 116(sp)
-	lwz r30, 120(sp)
-	lwz r31, 124(sp)
-	
-	lwz r12, 128(sp)
-	mtcr r12
-	
-	lwz r12, 132(sp)
-	mtsrr0 r12
-	
-	lwz r12, 136(sp)
-	mtsrr1 r12
-	
-	lwz r12, 140(sp)
-	mtlr r12
-	
-	lwz r12, 144(sp)
-	mtctr r12
-	
-	lwz r12, 148(sp)
-	mtxer r12
-	
-	lwz r12, 156(sp)
-	lwz sp, 160(sp)
-	
-	rfi
Index: kernel/arch/ppc32/src/interrupt.c
===================================================================
--- kernel/arch/ppc32/src/interrupt.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/src/interrupt.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -42,4 +42,5 @@
 #include <arch/drivers/pic.h>
 #include <arch/mm/tlb.h>
+#include <arch/mm/pht.h>
 #include <print.h>
 
@@ -54,44 +55,44 @@
 void istate_decode(istate_t *istate)
 {
-	printf("r0 =%#0" PRIx32 "\tr1 =%p\tr2 =%#0" PRIx32 "\n",
-	    istate->r0, (void *) istate->sp, istate->r2);
+	printf("r0 =%0#10" PRIx32 "\tr1 =%0#10" PRIx32 "\t"
+	    "r2 =%0#10" PRIx32 "\n", istate->r0, istate->sp, istate->r2);
 	
-	printf("r3 =%#0" PRIx32 "\tr4 =%#0" PRIx32 "\tr5 =%#0" PRIx32 "\n",
-	    istate->r3, istate->r4, istate->r5);
+	printf("r3 =%0#10" PRIx32 "\tr4 =%0#10" PRIx32 "\t"
+	    "r5 =%0#10" PRIx32 "\n", istate->r3, istate->r4, istate->r5);
 	
-	printf("r6 =%#0" PRIx32 "\tr7 =%#0" PRIx32 "\tr8 =%#0" PRIx32 "\n",
-	    istate->r6, istate->r7, istate->r8);
+	printf("r6 =%0#10" PRIx32 "\tr7 =%0#10" PRIx32 "\t"
+	    "r8 =%0#10" PRIx32 "\n", istate->r6, istate->r7, istate->r8);
 	
-	printf("r9 =%#0" PRIx32 "\tr10=%#0" PRIx32 "\tr11=%#0" PRIx32 "\n",
-	    istate->r9, istate->r10, istate->r11);
+	printf("r9 =%0#10" PRIx32 "\tr10=%0#10" PRIx32 "\t"
+	    "r11=%0#10" PRIx32 "\n", istate->r9, istate->r10, istate->r11);
 	
-	printf("r12=%#0" PRIx32 "\tr13=%#0" PRIx32 "\tr14=%#0" PRIx32 "\n",
-	    istate->r12, istate->r13, istate->r14);
+	printf("r12=%0#10" PRIx32 "\tr13=%0#10" PRIx32 "\t"
+	    "r14=%0#10" PRIx32 "\n", istate->r12, istate->r13, istate->r14);
 	
-	printf("r15=%#0" PRIx32 "\tr16=%#0" PRIx32 "\tr17=%#0" PRIx32 "\n",
-	    istate->r15, istate->r16, istate->r17);
+	printf("r15=%0#10" PRIx32 "\tr16=%0#10" PRIx32 "\t"
+	    "r17=%0#10" PRIx32 "\n", istate->r15, istate->r16, istate->r17);
 	
-	printf("r18=%#0" PRIx32 "\tr19=%#0" PRIx32 "\tr20=%#0" PRIx32 "\n",
-	    istate->r18, istate->r19, istate->r20);
+	printf("r18=%0#10" PRIx32 "\tr19=%0#10" PRIx32 "\t"
+	    "r20=%0#10" PRIx32 "\n", istate->r18, istate->r19, istate->r20);
 	
-	printf("r21=%#0" PRIx32 "\tr22=%#0" PRIx32 "\tr23=%#0" PRIx32 "\n",
-	    istate->r21, istate->r22, istate->r23);
+	printf("r21=%0#10" PRIx32 "\tr22=%0#10" PRIx32 "\t"
+	    "r23=%0#10" PRIx32 "\n", istate->r21, istate->r22, istate->r23);
 	
-	printf("r24=%#0" PRIx32 "\tr25=%#0" PRIx32 "\tr26=%#0" PRIx32 "\n",
-	    istate->r24, istate->r25, istate->r26);
+	printf("r24=%0#10" PRIx32 "\tr25=%0#10" PRIx32 "\t"
+	    "r26=%0#10" PRIx32 "\n", istate->r24, istate->r25, istate->r26);
 	
-	printf("r27=%#0" PRIx32 "\tr28=%#0" PRIx32 "\tr29=%#0" PRIx32 "\n",
-	    istate->r27, istate->r28, istate->r29);
+	printf("r27=%0#10" PRIx32 "\tr28=%0#10" PRIx32 "\t"
+	    "r29=%0#10" PRIx32 "\n", istate->r27, istate->r28, istate->r29);
 	
-	printf("r30=%#0" PRIx32 "\tr31=%#0" PRIx32 "\n",
+	printf("r30=%0#10" PRIx32 "\tr31=%0#10" PRIx32 "\n",
 	    istate->r30, istate->r31);
 	
-	printf("cr =%#0" PRIx32 "\tpc =%p\tlr =%p\n",
-	    istate->cr, (void *) istate->pc, (void *) istate->lr);
+	printf("cr =%0#10" PRIx32 "\tpc =%0#10" PRIx32 "\t"
+	    "lr =%0#10" PRIx32 "\n", istate->cr, istate->pc, istate->lr);
 	
-	printf("ctr=%#0" PRIx32 "\txer=%#0" PRIx32 "\tdar=%#0" PRIx32 "\n",
-	    istate->ctr, istate->xer, istate->dar);
+	printf("ctr=%0#10" PRIx32 "\txer=%0#10" PRIx32 "\t"
+	    "dar=%0#10" PRIx32 "\n", istate->ctr, istate->xer, istate->dar);
 	
-	printf("srr1=%p\n", (void *) istate->srr1);
+	printf("srr1=%0#10" PRIx32 "\n", istate->srr1);
 }
 
@@ -153,4 +154,10 @@
 	exc_register(VECTOR_DECREMENTER, "timer", true,
 	    exception_decrementer);
+	exc_register(VECTOR_ITLB_MISS, "itlb_miss", true,
+	    tlb_refill);
+	exc_register(VECTOR_DTLB_MISS_LOAD, "dtlb_miss_load", true,
+	    tlb_refill);
+	exc_register(VECTOR_DTLB_MISS_STORE, "dtlb_miss_store", true,
+	    tlb_refill);
 }
 
Index: kernel/arch/ppc32/src/mm/page.c
===================================================================
--- kernel/arch/ppc32/src/mm/page.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/src/mm/page.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -43,4 +43,5 @@
 	if (config.cpu_active == 1)
 		page_mapping_operations = &pt_mapping_operations;
+	as_switch(NULL, AS_KERNEL);
 }
 
Index: kernel/arch/ppc32/src/mm/pht.c
===================================================================
--- kernel/arch/ppc32/src/mm/pht.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
+++ kernel/arch/ppc32/src/mm/pht.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -0,0 +1,245 @@
+/*
+ * Copyright (c) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ppc32mm
+ * @{
+ */
+/** @file
+ */
+
+#include <arch/mm/pht.h>
+#include <arch/mm/tlb.h>
+#include <interrupt.h>
+#include <mm/as.h>
+#include <mm/page.h>
+#include <macros.h>
+#include <typedefs.h>
+
+static unsigned int seed = 42;
+
+/** Try to find PTE for faulting address
+ *
+ * @param as       Address space.
+ * @param badvaddr Faulting virtual address.
+ * @param access   Access mode that caused the fault.
+ * @param istate   Pointer to interrupted state.
+ * @param pfrc     Pointer to variable where as_page_fault() return code
+ *                 will be stored.
+ *
+ * @return PTE on success, NULL otherwise.
+ *
+ */
+static pte_t *find_mapping_and_check(as_t *as, uintptr_t badvaddr, int access,
+    istate_t *istate, int *pfrc)
+{
+	/*
+	 * Check if the mapping exists in page tables.
+	 */
+	pte_t *pte = page_mapping_find(as, badvaddr, true);
+	if ((pte) && (pte->present)) {
+		/*
+		 * Mapping found in page tables.
+		 * Immediately succeed.
+		 */
+		return pte;
+	} else {
+		/*
+		 * Mapping not found in page tables.
+		 * Resort to higher-level page fault handler.
+		 */
+		int rc = as_page_fault(badvaddr, access, istate);
+		switch (rc) {
+		case AS_PF_OK:
+			/*
+			 * The higher-level page fault handler succeeded,
+			 * The mapping ought to be in place.
+			 */
+			pte = page_mapping_find(as, badvaddr, true);
+			ASSERT((pte) && (pte->present));
+			*pfrc = 0;
+			return pte;
+		case AS_PF_DEFER:
+			*pfrc = rc;
+			return NULL;
+		case AS_PF_FAULT:
+			*pfrc = rc;
+			return NULL;
+		default:
+			panic("Unexpected rc (%d).", rc);
+		}
+	}
+}
+
+static void pht_refill_fail(uintptr_t badvaddr, istate_t *istate)
+{
+	fault_if_from_uspace(istate, "PHT Refill Exception on %p.",
+	    (void *) badvaddr);
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, badvaddr,
+	    "PHT Refill Exception.");
+}
+
+static void pht_insert(const uintptr_t vaddr, const pte_t *pte)
+{
+	uint32_t page = (vaddr >> 12) & 0xffff;
+	uint32_t api = (vaddr >> 22) & 0x3f;
+	
+	uint32_t vsid = sr_get(vaddr);
+	uint32_t sdr1 = sdr1_get();
+	
+	// FIXME: compute size of PHT exactly
+	phte_t *phte = (phte_t *) PA2KA(sdr1 & 0xffff0000);
+	
+	/* Primary hash (xor) */
+	uint32_t h = 0;
+	uint32_t hash = vsid ^ page;
+	uint32_t base = (hash & 0x3ff) << 3;
+	uint32_t i;
+	bool found = false;
+	
+	/* Find colliding PTE in PTEG */
+	for (i = 0; i < 8; i++) {
+		if ((phte[base + i].v)
+		    && (phte[base + i].vsid == vsid)
+		    && (phte[base + i].api == api)
+		    && (phte[base + i].h == 0)) {
+			found = true;
+			break;
+		}
+	}
+	
+	if (!found) {
+		/* Find unused PTE in PTEG */
+		for (i = 0; i < 8; i++) {
+			if (!phte[base + i].v) {
+				found = true;
+				break;
+			}
+		}
+	}
+	
+	if (!found) {
+		/* Secondary hash (not) */
+		uint32_t base2 = (~hash & 0x3ff) << 3;
+		
+		/* Find colliding PTE in PTEG */
+		for (i = 0; i < 8; i++) {
+			if ((phte[base2 + i].v)
+			    && (phte[base2 + i].vsid == vsid)
+			    && (phte[base2 + i].api == api)
+			    && (phte[base2 + i].h == 1)) {
+				found = true;
+				base = base2;
+				h = 1;
+				break;
+			}
+		}
+		
+		if (!found) {
+			/* Find unused PTE in PTEG */
+			for (i = 0; i < 8; i++) {
+				if (!phte[base2 + i].v) {
+					found = true;
+					base = base2;
+					h = 1;
+					break;
+				}
+			}
+		}
+		
+		if (!found)
+			i = RANDI(seed) % 8;
+	}
+	
+	phte[base + i].v = 1;
+	phte[base + i].vsid = vsid;
+	phte[base + i].h = h;
+	phte[base + i].api = api;
+	phte[base + i].rpn = pte->pfn;
+	phte[base + i].r = 0;
+	phte[base + i].c = 0;
+	phte[base + i].wimg = (pte->page_cache_disable ? WIMG_NO_CACHE : 0);
+	phte[base + i].pp = 2; // FIXME
+}
+
+/** Process Instruction/Data Storage Exception
+ *
+ * @param n      Exception vector number.
+ * @param istate Interrupted register context.
+ *
+ */
+void pht_refill(unsigned int n, istate_t *istate)
+{
+	uintptr_t badvaddr;
+	
+	if (n == VECTOR_DATA_STORAGE)
+		badvaddr = istate->dar;
+	else
+		badvaddr = istate->pc;
+	
+	int pfrc;
+	pte_t *pte = find_mapping_and_check(AS, badvaddr,
+	    PF_ACCESS_READ /* FIXME */, istate, &pfrc);
+	
+	if (!pte) {
+		switch (pfrc) {
+		case AS_PF_FAULT:
+			pht_refill_fail(badvaddr, istate);
+			return;
+		case AS_PF_DEFER:
+			/*
+			 * The page fault came during copy_from_uspace()
+			 * or copy_to_uspace().
+			 */
+			return;
+		default:
+			panic("Unexpected pfrc (%d).", pfrc);
+		}
+	}
+	
+	/* Record access to PTE */
+	pte->accessed = 1;
+	pht_insert(badvaddr, pte);
+}
+
+void pht_invalidate(as_t *as, uintptr_t page, size_t pages)
+{
+	uint32_t sdr1 = sdr1_get();
+	
+	// FIXME: compute size of PHT exactly
+	phte_t *phte = (phte_t *) PA2KA(sdr1 & 0xffff0000);
+	
+	// FIXME: this invalidates all PHT entries,
+	// which is an overkill, invalidate only
+	// selectively
+	for (size_t i = 0; i < 8192; i++) {
+		phte[i].v = 0;
+	}
+}
+
+/** @}
+ */
